=== modified file 'drizzled/join.cc'
--- drizzled/join.cc	2009-07-16 21:19:14 +0000
+++ drizzled/join.cc	2009-07-23 21:28:28 +0000
@@ -2085,7 +2085,6 @@
       tmp_join->tmp_table_param.copy_field=
         tmp_join->tmp_table_param.save_copy_field= 0;
     }
-    tmp_table_param.cleanup();
   }
   return;
 }

=== modified file 'drizzled/join.h'
--- drizzled/join.h	2009-07-16 21:19:14 +0000
+++ drizzled/join.h	2009-07-23 21:28:28 +0000
@@ -291,7 +291,6 @@
     if (&fields_list != &fields_arg) /* only copy if not same*/
       fields_list= fields_arg;
     memset(&keyuse, 0, sizeof(keyuse));
-    tmp_table_param.init();
     tmp_table_param.end_write_records= HA_POS_ERROR;
     rollup.state= ROLLUP::STATE_NONE;
   }
@@ -381,7 +380,6 @@
     if (&fields_list != &fields_arg) /* only copy if not same*/
       fields_list= fields_arg;
     memset(&keyuse, 0, sizeof(keyuse));
-    tmp_table_param.init();
     tmp_table_param.end_write_records= HA_POS_ERROR;
     rollup.state= ROLLUP::STATE_NONE;
   }

=== modified file 'drizzled/session.cc'
--- drizzled/session.cc	2009-07-11 08:51:36 +0000
+++ drizzled/session.cc	2009-07-23 21:28:28 +0000
@@ -1588,30 +1588,6 @@
   return false;
 }
 
-/****************************************************************************
-  Tmp_Table_Param
-****************************************************************************/
-
-void Tmp_Table_Param::init()
-{
-  field_count= sum_func_count= func_count= hidden_field_count= 0;
-  group_parts= group_length= group_null_parts= 0;
-  quick_group= 1;
-  table_charset= 0;
-  precomputed_group_by= 0;
-  bit_fields_as_long= 0;
-}
-
-void Tmp_Table_Param::cleanup(void)
-{
-  /* Fix for Intel compiler */
-  if (copy_field)
-  {
-    delete [] copy_field;
-    save_copy_field= copy_field= 0;
-  }
-}
-
 void Session::send_kill_message() const
 {
   int err= killed_errno();

=== modified file 'drizzled/show.cc'
--- drizzled/show.cc	2009-07-11 08:51:36 +0000
+++ drizzled/show.cc	2009-07-23 21:28:28 +0000
@@ -2760,9 +2760,7 @@
     field_count++;
     ++iter;
   }
-  Tmp_Table_Param *tmp_table_param =
-    (Tmp_Table_Param*) (session->alloc(sizeof(Tmp_Table_Param)));
-  tmp_table_param->init();
+  Tmp_Table_Param *tmp_table_param= new Tmp_Table_Param;
   tmp_table_param->table_charset= cs;
   tmp_table_param->field_count= field_count;
   tmp_table_param->schema_table= 1;

=== modified file 'drizzled/sql_union.cc'
--- drizzled/sql_union.cc	2009-05-29 23:52:19 +0000
+++ drizzled/sql_union.cc	2009-07-23 21:28:28 +0000
@@ -119,7 +119,6 @@
                                   bool bit_fields_as_long)
 {
   assert(table == 0);
-  tmp_table_param.init();
   tmp_table_param.field_count= column_types->elements;
   tmp_table_param.bit_fields_as_long= bit_fields_as_long;
 

=== modified file 'drizzled/sql_update.cc'
--- drizzled/sql_update.cc	2009-07-11 08:51:36 +0000
+++ drizzled/sql_update.cc	2009-07-23 21:28:28 +0000
@@ -1009,8 +1009,7 @@
   table_count=  update_tables.size();
 
   tmp_tables = (Table**) session->calloc(sizeof(Table *) * table_count);
-  tmp_table_param = (Tmp_Table_Param*) session->calloc(sizeof(Tmp_Table_Param) *
-						   table_count);
+  tmp_table_param= new Tmp_Table_Param[table_count];
   fields_for_table= (List_item **) session->alloc(sizeof(List_item *) *
 					      table_count);
   values_for_table= (List_item **) session->alloc(sizeof(List_item *) *
@@ -1229,11 +1228,13 @@
     {
       if (tmp_tables[cnt])
       {
-	tmp_tables[cnt]->free_tmp_table(session);
-	tmp_table_param[cnt].cleanup();
+        tmp_tables[cnt]->free_tmp_table(session);
       }
     }
   }
+
+  delete [] tmp_table_param;
+  
   if (copy_field)
     delete [] copy_field;
   session->count_cuted_fields= CHECK_FIELD_IGNORE;		// Restore this setting

=== modified file 'drizzled/tmp_table_param.h'
--- drizzled/tmp_table_param.h	2009-06-05 22:22:21 +0000
+++ drizzled/tmp_table_param.h	2009-07-23 21:28:28 +0000
@@ -27,7 +27,7 @@
     This structure is copied using memcpy as a part of JOIN.
 */
 
-class Tmp_Table_Param :public Sql_alloc
+class Tmp_Table_Param
 {
 private:
   /* Prevent use of these (not safe because of lists and copy_field) */
@@ -75,22 +75,37 @@
   bool bit_fields_as_long;
 
   Tmp_Table_Param()
-    :copy_field(0),
-    group_parts(0),
-    group_length(0),
-    group_null_parts(0),
-    schema_table(false),
-    precomputed_group_by(false),
-    force_copy_fields(false),
-    convert_blob_length(0),
-    bit_fields_as_long(false)
+    : keyinfo(NULL),
+      copy_field(NULL),
+      copy_field_end(NULL),
+      save_copy_field(NULL),
+      save_copy_field_end(NULL),
+      group_buff(NULL),
+      items_to_copy(0),
+      recinfo(NULL),
+      start_recinfo(NULL),
+      end_write_records(0),
+      field_count(0),
+      sum_func_count(0),
+      func_count(0),
+      hidden_field_count(0),
+      group_parts(0),
+      group_length(0),
+      group_null_parts(0),
+      quick_group(1),
+      using_indirect_summary_function(false),
+      schema_table(false),
+      precomputed_group_by(false),
+      force_copy_fields(false),
+      convert_blob_length(0),
+      table_charset(NULL),
+      bit_fields_as_long(false)
   {}
+
   ~Tmp_Table_Param()
   {
-    cleanup();
+    delete [] copy_field;
   }
-  void init(void);
-  void cleanup(void);
 };
 
 #endif /* DRIZZLED_TMP_TABLE_PARAM_H */

